﻿
Public Class Form1
    ''' <summary>
    ''' このサンプルコードはARIESのRS-232C制御のプログラムを作成する参考に作成されたものです。
    ''' 商用・非商用を問わず実用を考慮した設計にはなっていません。
    ''' <NR></NR>
    ''' 弊社の環境にて動作確認をしておりますが、いかなる環境でも動作することを保証しておりません。
    ''' <NR></NR>
    ''' 起動をするとシリアルポートコンポーネントを立ち上げ、ポートを開きます。
    ''' 次に「IDN」ボタンを押下するとIDNコマンドを送信し、型式を受信します。
    ''' このアプリを閉じるときにポートを閉じます。
    ''' <NR></NR>   
    ''' このサンプルコードの著作権は神津精機株式会社に帰属します。
    ''' Copylight　2018　Kohzu Precision Co., Ltd.
    ''' written by M.O.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'ボーレートを設定します。コントローラのボーレートを書き込んでください。
        'SerialPort1.BaudRate = 115200
        serialPort1.BaudRate = 57600
        'SerialPort1.BaudRate = 38400

        'ポート番号を設定します。
        serialPort1.PortName = "COM1"
        'SerialPort1.PortName = "COM2"
        'SerialPort1.PortName = "COM3"
        'SerialPort1.PortName = "COM4"
        'SerialPort1.PortName = "COM5"
        'SerialPort1.PortName = "COM6"
        'SerialPort1.PortName = "COM7"
        'SerialPort1.PortName = "COM8"
        'SerialPort1.PortName = "COM9"

        'シリアルポートを開きます。
        serialPort1.Open()

        textBox1.Text = DateTime.Now.ToLongDateString() & vbTab & serialPort1.PortName _
            & vbTab & "ポートを開きました。コントローラのボーレートを" & serialPort1.BaudRate & "baudに設定してください。" & vbCrLf

    End Sub

    ''' <summary>
    ''' このフォームを閉じる直前に実行されます
    ''' </summary>
    ''' <param name="sender">送信元のオブジェクトです</param>
    ''' <param name="e">送信パラメータです</param>
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        'シリアルポートを閉じます。
        serialPort1.Close()
    End Sub

    'コントローラの型式を格納します
    Private ControllerType As String = "Unknown"

    '送信コマンドを格納します
    Private SendCommand As String = "Unknown"

    ''' <summary>
    ''' serialPort1にデータを受信すると発生します
    ''' </summary>
    ''' <param name="sender">送信元オブジェクトです</param>
    ''' <param name="e">イベントデータです</param>
    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        'IDNボタンを利用不可にします
        button1.Enabled = False

        '受信バッファのデータを破棄します
        serialPort1.DiscardInBuffer()

        'IDNコマンドの文字列を準備する
        Dim sentTxt As String = Chr(2) & "IDN" & vbCrLf
        Dim sentMsg As Byte() = New Byte() {}

        sentMsg = System.Text.Encoding.ASCII.GetBytes(sentTxt.ToCharArray())

        'シリアルポートにリモートコマンドを送信します        
        serialPort1.Write(sentMsg, 0, sentMsg.Length)

        'textBox1へ表示します
        textBox1.Text += DateTime.Now.ToLongTimeString() & vbTab _
            & serialPort1.PortName & vbTab _
            & "←" & sentTxt.Substring(1, 3) & "コマンドを送信しました。" & vbCrLf

        Do
            'IDNコマンドへの返信があった場合の処理です　
            If (SendCommand.Equals("IDN")) Then

                'SendCommandを開放します
                SendCommand = "Unknown"

                'textBox1へ表示します
                textBox1.Text += DateTime.Now.ToLongTimeString() & vbTab _
                    & serialPort1.PortName & vbTab & "→ 接続されているコントローラは" & ControllerType & "です。" & vbCrLf

                'ControllerTypeを開放します
                ControllerType = "Unknown"

                Exit Do

            End If
        Loop

        'IDNボタンの利用をできるようにします。
        button1.Enabled = True
    End Sub

    ''' <summary>
    ''' serialPort1にデータを受信すると発生します
    ''' </summary>
    ''' <param name="sender">送信元オブジェクトです</param>
    ''' <param name="e">イベントパラメータです</param>
    Private Sub serialPort1_DataReceived(sender As Object, e As IO.Ports.SerialDataReceivedEventArgs) Handles serialPort1.DataReceived
        '受信バッファ内のバイト数を取得します。
        Dim bytes As Byte = Me.serialPort1.BytesToRead

        Dim ReceivedBytes As Byte() = New Byte(bytes) {}
        Dim rc1 As Char() = New Char(bytes) {}

        Dim ReceivedText As String = ""

        Dim Answers As String() = New String() {}

        Do
            '受信バッファ内のバイトを読み取ります。
            serialPort1.Read(ReceivedBytes, 0, bytes)

            For i = 0 To ReceivedBytes.Length - 1

                '読み取ったバイトをUTF-8に変換します。
                ReceivedText += Convert.ToChar(ReceivedBytes(i))

                If (ReceivedText.Substring(ReceivedText.Length - 1, 1).Equals(vbCr)) Then
                    '\rであればAnswers配列に格納します。
                    Answers = ReceivedText.Split(vbTab)

                    SendCommand = Answers(1)
                    ControllerType = Answers(2)
                    Return

                End If
            Next
        Loop

    End Sub
End Class


